Subject: Re: [Xen-devel] [PATCH 0/4] Implement persistent grant in xen-netfront/netback

From: Konrad Rzeszutek Wilk <[email-masked]>
Date: Thu, 15 Nov 2012 13:29:28 -0500

On Thu, Nov 15, 2012 at 11:15:06AM +0000, Ian Campbell wrote:
> On Thu, 2012-11-15 at 10:56 +0000, Roger Pau Monne wrote:
> > On 15/11/12 09:38, ANNIE LI wrote:
> > > 
> > > 
> > > On 2012-11-15 15:40, Pasi Kärkkäinen wrote:
> > >> Hello,
> > >>
> > >> On Thu, Nov 15, 2012 at 03:03:07PM +0800, Annie Li wrote:
> > >>> This patch implements persistent grants for xen-netfront/netback. This
> > >>> mechanism maintains page pools in netback/netfront, these page pools is used to
> > >>> save grant pages which are mapped. This way improve performance which is wasted
> > >>> when doing grant operations.
> > >>>
> > >>> Current netback/netfront does map/unmap grant operations frequently when
> > >>> transmitting/receiving packets, and grant operations costs much cpu clock. In
> > >>> this patch, netfront/netback maps grant pages when needed and then saves them
> > >>> into a page pool for future use. All these pages will be unmapped when
> > >>> removing/releasing the net device.
> > >>>
> > >> Do you have performance numbers available already? with/without persistent grants?
> > > I have some simple netperf/netserver test result with/without persistent 
> > > grants,
> > > 
> > > Following is result of with persistent grant patch,
> > > 
> > > Guests, Sum,      Avg,     Min,     Max
> > >   1,  15106.4,  15106.4, 15106.36, 15106.36
> > >   2,  13052.7,  6526.34,  6261.81,  6790.86
> > >   3,  12675.1,  6337.53,  6220.24,  6454.83
> > >   4,  13194,  6596.98,  6274.70,  6919.25
> > > 
> > > 
> > > Following are result of without persistent patch
> > > 
> > > Guests, Sum,     Avg,    Min,        Max
> > >   1,  10864.1,  10864.1, 10864.10, 10864.10
> > >   2,  10898.5,  5449.24,  4862.08,  6036.40
> > >   3,  10734.5,  5367.26,  5261.43,  5473.08
> > >   4,  10924,    5461.99,  5314.84,  5609.14
> > 
> > In the block case, performance improvement is seen when using a large
> > number of guests, could you perform the same benchmark increasing the
> > number of guests to 15?
> 
> It would also be nice to see some analysis of the numbers which justify
> why this change is a good one without every reviewer having to evaluate
> the raw data themselves. In fact this should really be part of the
> commit message.

You mean like a nice graph, eh?

I will run these patches on my 32GB box and see if I can give you
a nice PDF/jpg.

> Ian.